DescriptorProtos.FieldDescriptorProto
Date: 2017-07-08

com.google.protobuf

## Class DescriptorProtos.FieldDescriptorProto

- java.lang.Object
- - com.google.protobuf.AbstractMessageLite
  - - com.google.protobuf.AbstractMessage
    - - com.google.protobuf.GeneratedMessageV3
      - - com.google.protobuf.DescriptorProtos.FieldDescriptorProto

- All Implemented Interfaces:
    DescriptorProtos.FieldDescriptorProtoOrBuilder, Message, MessageLite, MessageLiteOrBuilder, MessageOrBuilder, java.io.Serializable
  Enclosing class:
    DescriptorProtos

      public static final class DescriptorProtos.FieldDescriptorProto
      extends GeneratedMessageV3
      implements DescriptorProtos.FieldDescriptorProtoOrBuilder

       Describes a field within a message.

  Protobuf type `google.protobuf.FieldDescriptorProto`
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `DescriptorProtos.FieldDescriptorProto.Builder` Describes a field within a message.
    `static class` | `DescriptorProtos.FieldDescriptorProto.Label` Protobuf enum `google.protobuf.FieldDescriptorProto.Label`
    `static class` | `DescriptorProtos.FieldDescriptorProto.Type` Protobuf enum `google.protobuf.FieldDescriptorProto.Type`

    - ### Nested classes/interfaces inherited from class com.google.protobuf.GeneratedMessageV3

      `GeneratedMessageV3.BuilderParent, GeneratedMessageV3.ExtendableBuilder<MessageType extends GeneratedMessageV3.ExtendableMessage,BuilderType extends GeneratedMessageV3.ExtendableBuilder<MessageType,BuilderType>>, GeneratedMessageV3.ExtendableMessage<MessageType extends GeneratedMessageV3.ExtendableMessage>, GeneratedMessageV3.ExtendableMessageOrBuilder<MessageType extends GeneratedMessageV3.ExtendableMessage>, GeneratedMessageV3.FieldAccessorTable`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `DEFAULT_VALUE_FIELD_NUMBER`
    `static int` | `EXTENDEE_FIELD_NUMBER`
    `static int` | `JSON_NAME_FIELD_NUMBER`
    `static int` | `LABEL_FIELD_NUMBER`
    `static int` | `NAME_FIELD_NUMBER`
    `static int` | `NUMBER_FIELD_NUMBER`
    `static int` | `ONEOF_INDEX_FIELD_NUMBER`
    `static int` | `OPTIONS_FIELD_NUMBER`
    `static Parser<DescriptorProtos.FieldDescriptorProto>` | `PARSER` Deprecated.
    `static int` | `TYPE_FIELD_NUMBER`
    `static int` | `TYPE_NAME_FIELD_NUMBER`

    - ### Fields inherited from class com.google.protobuf.GeneratedMessageV3

      `alwaysUseFieldBuilders, unknownFields`

    - ### Fields inherited from class com.google.protobuf.AbstractMessage

      `memoizedSize`

    - ### Fields inherited from class com.google.protobuf.AbstractMessageLite

      `memoizedHashCode`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(java.lang.Object obj)` Compares the specified object with this message for equality.
    `static DescriptorProtos.FieldDescriptorProto` | `getDefaultInstance()`
    `DescriptorProtos.FieldDescriptorProto` | `getDefaultInstanceForType()` Get an instance of the type with no fields set.
    `java.lang.String` | `getDefaultValue()` For numeric types, contains the original text representation of the value.
    `ByteString` | `getDefaultValueBytes()` For numeric types, contains the original text representation of the value.
    `static Descriptors.Descriptor` | `getDescriptor()`
    `java.lang.String` | `getExtendee()` For extensions, this is the name of the type being extended.
    `ByteString` | `getExtendeeBytes()` For extensions, this is the name of the type being extended.
    `java.lang.String` | `getJsonName()` JSON name of this field.
    `ByteString` | `getJsonNameBytes()` JSON name of this field.
    `DescriptorProtos.FieldDescriptorProto.Label` | `getLabel()` `optional .google.protobuf.FieldDescriptorProto.Label label = 4;`
    `java.lang.String` | `getName()` `optional string name = 1;`
    `ByteString` | `getNameBytes()` `optional string name = 1;`
    `int` | `getNumber()` `optional int32 number = 3;`
    `int` | `getOneofIndex()` If set, gives the index of a oneof in the containing type's oneof_decl list.
    `DescriptorProtos.FieldOptions` | `getOptions()` `optional .google.protobuf.FieldOptions options = 8;`
    `DescriptorProtos.FieldOptionsOrBuilder` | `getOptionsOrBuilder()` `optional .google.protobuf.FieldOptions options = 8;`
    `Parser<DescriptorProtos.FieldDescriptorProto>` | `getParserForType()` Gets the parser for a message of the same type as this message.
    `int` | `getSerializedSize()` Get the number of bytes required to encode this message.
    `DescriptorProtos.FieldDescriptorProto.Type` | `getType()` If type_name is set, this need not be set.
    `java.lang.String` | `getTypeName()` For message and enum types, this is the name of the type.
    `ByteString` | `getTypeNameBytes()` For message and enum types, this is the name of the type.
    `UnknownFieldSet` | `getUnknownFields()` Get the `UnknownFieldSet` for this message.
    `boolean` | `hasDefaultValue()` For numeric types, contains the original text representation of the value.
    `boolean` | `hasExtendee()` For extensions, this is the name of the type being extended.
    `int` | `hashCode()` Returns the hash code value for this message.
    `boolean` | `hasJsonName()` JSON name of this field.
    `boolean` | `hasLabel()` `optional .google.protobuf.FieldDescriptorProto.Label label = 4;`
    `boolean` | `hasName()` `optional string name = 1;`
    `boolean` | `hasNumber()` `optional int32 number = 3;`
    `boolean` | `hasOneofIndex()` If set, gives the index of a oneof in the containing type's oneof_decl list.
    `boolean` | `hasOptions()` `optional .google.protobuf.FieldOptions options = 8;`
    `boolean` | `hasType()` If type_name is set, this need not be set.
    `boolean` | `hasTypeName()` For message and enum types, this is the name of the type.
    `protected GeneratedMessageV3.FieldAccessorTable` | `internalGetFieldAccessorTable()` Get the FieldAccessorTable for this type.
    `boolean` | `isInitialized()` Returns true if all required fields in the message and all embedded messages are set, false otherwise.
    `static DescriptorProtos.FieldDescriptorProto.Builder` | `newBuilder()`
    `static DescriptorProtos.FieldDescriptorProto.Builder` | `newBuilder(DescriptorProtos.FieldDescriptorProto prototype)`
    `DescriptorProtos.FieldDescriptorProto.Builder` | `newBuilderForType()` Constructs a new builder for a message of the same type as this message.
    `protected DescriptorProtos.FieldDescriptorProto.Builder` | `newBuilderForType(GeneratedMessageV3.BuilderParent parent)` TODO(xiaofeng): remove this together with GeneratedMessageV3.BuilderParent.
    `static DescriptorProtos.FieldDescriptorProto` | `parseDelimitedFrom(java.io.InputStream input)`
    `static DescriptorProtos.FieldDescriptorProto` | `parseDelimitedFrom(java.io.InputStream input, ExtensionRegistryLite extensionRegistry)`
    `static DescriptorProtos.FieldDescriptorProto` | `parseFrom(byte[] data)`
    `static DescriptorProtos.FieldDescriptorProto` | `parseFrom(byte[] data, ExtensionRegistryLite extensionRegistry)`
    `static DescriptorProtos.FieldDescriptorProto` | `parseFrom(java.nio.ByteBuffer data)`
    `static DescriptorProtos.FieldDescriptorProto` | `parseFrom(java.nio.ByteBuffer data, ExtensionRegistryLite extensionRegistry)`
    `static DescriptorProtos.FieldDescriptorProto` | `parseFrom(ByteString data)`
    `static DescriptorProtos.FieldDescriptorProto` | `parseFrom(ByteString data, ExtensionRegistryLite extensionRegistry)`
    `static DescriptorProtos.FieldDescriptorProto` | `parseFrom(CodedInputStream input)`
    `static DescriptorProtos.FieldDescriptorProto` | `parseFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry)`
    `static DescriptorProtos.FieldDescriptorProto` | `parseFrom(java.io.InputStream input)`
    `static DescriptorProtos.FieldDescriptorProto` | `parseFrom(java.io.InputStream input, ExtensionRegistryLite extensionRegistry)`
    `static Parser<DescriptorProtos.FieldDescriptorProto>` | `parser()`
    `DescriptorProtos.FieldDescriptorProto.Builder` | `toBuilder()` Constructs a builder initialized with the current message.
    `void` | `writeTo(CodedOutputStream output)` Serializes the message and writes it to `output`.

    - ### Methods inherited from class com.google.protobuf.GeneratedMessageV3

      `computeStringSize, computeStringSizeNoTag, getAllFields, getDescriptorForType, getField, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, hasField, hasOneof, internalGetMapField, makeExtensionsImmutable, newBuilderForType, parseDelimitedWithIOException, parseDelimitedWithIOException, parseUnknownField, parseWithIOException, parseWithIOException, parseWithIOException, parseWithIOException, serializeBooleanMapTo, serializeIntegerMapTo, serializeLongMapTo, serializeStringMapTo, writeReplace, writeString, writeStringNoTag`

    - ### Methods inherited from class com.google.protobuf.AbstractMessage

      `findInitializationErrors, getInitializationErrorString, hashBoolean, hashEnum, hashEnumList, hashFields, hashLong, toString`

    - ### Methods inherited from class com.google.protobuf.AbstractMessageLite

      `addAll, checkByteStringIsUtf8, toByteArray, toByteString, writeDelimitedTo, writeTo`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.protobuf.MessageOrBuilder

      `findInitializationErrors, getAllFields, getDescriptorForType, getField, getInitializationErrorString, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, hasField, hasOneof`

    - ### Methods inherited from interface com.google.protobuf.MessageLite

      `toByteArray, toByteString, writeDelimitedTo, writeTo`

- - ### Field Detail

    - #### NAME_FIELD_NUMBER

          public static final int NAME_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### NUMBER_FIELD_NUMBER

          public static final int NUMBER_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### LABEL_FIELD_NUMBER

          public static final int LABEL_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### TYPE_FIELD_NUMBER

          public static final int TYPE_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### TYPE_NAME_FIELD_NUMBER

          public static final int TYPE_NAME_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### EXTENDEE_FIELD_NUMBER

          public static final int EXTENDEE_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### DEFAULT_VALUE_FIELD_NUMBER

          public static final int DEFAULT_VALUE_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### ONEOF_INDEX_FIELD_NUMBER

          public static final int ONEOF_INDEX_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### JSON_NAME_FIELD_NUMBER

          public static final int JSON_NAME_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### OPTIONS_FIELD_NUMBER

          public static final int OPTIONS_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### PARSER

          @Deprecated
          public static final Parser<DescriptorProtos.FieldDescriptorProto> PARSER

      Deprecated.

  - ### Method Detail

    - #### getUnknownFields

          public final UnknownFieldSet getUnknownFields()

      Description copied from interface: `MessageOrBuilder`
      Get the `UnknownFieldSet` for this message.
      Specified by:
        `getUnknownFields` in interface `MessageOrBuilder`
      Overrides:
        `getUnknownFields` in class `GeneratedMessageV3`

    - #### getDescriptor

          public static final Descriptors.Descriptor getDescriptor()

    - #### internalGetFieldAccessorTable

          protected GeneratedMessageV3.FieldAccessorTable internalGetFieldAccessorTable()

      Description copied from class: `GeneratedMessageV3`
      Get the FieldAccessorTable for this type. We can't have the message class pass this in to the constructor because of bootstrapping trouble with DescriptorProtos.
      Specified by:
        `internalGetFieldAccessorTable` in class `GeneratedMessageV3`

    - #### hasName

          public boolean hasName()

      `optional string name = 1;`
      Specified by:
        `hasName` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### getName

          public java.lang.String getName()

      `optional string name = 1;`
      Specified by:
        `getName` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### getNameBytes

          public ByteString getNameBytes()

      `optional string name = 1;`
      Specified by:
        `getNameBytes` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### hasNumber

          public boolean hasNumber()

      `optional int32 number = 3;`
      Specified by:
        `hasNumber` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### getNumber

          public int getNumber()

      `optional int32 number = 3;`
      Specified by:
        `getNumber` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### hasLabel

          public boolean hasLabel()

      `optional .google.protobuf.FieldDescriptorProto.Label label = 4;`
      Specified by:
        `hasLabel` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### getLabel

          public DescriptorProtos.FieldDescriptorProto.Label getLabel()

      `optional .google.protobuf.FieldDescriptorProto.Label label = 4;`
      Specified by:
        `getLabel` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### hasType

          public boolean hasType()

           If type_name is set, this need not be set.  If both this and type_name
           are set, this must be one of TYPE_ENUM, TYPE_MESSAGE or TYPE_GROUP.

      `optional .google.protobuf.FieldDescriptorProto.Type type = 5;`
      Specified by:
        `hasType` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### getType

          public DescriptorProtos.FieldDescriptorProto.Type getType()

           If type_name is set, this need not be set.  If both this and type_name
           are set, this must be one of TYPE_ENUM, TYPE_MESSAGE or TYPE_GROUP.

      `optional .google.protobuf.FieldDescriptorProto.Type type = 5;`
      Specified by:
        `getType` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### hasTypeName

          public boolean hasTypeName()

           For message and enum types, this is the name of the type.  If the name
           starts with a '.', it is fully-qualified.  Otherwise, C++-like scoping
           rules are used to find the type (i.e. first the nested types within this
           message are searched, then within the parent, on up to the root
           namespace).

      `optional string type_name = 6;`
      Specified by:
        `hasTypeName` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### getTypeName

          public java.lang.String getTypeName()

           For message and enum types, this is the name of the type.  If the name
           starts with a '.', it is fully-qualified.  Otherwise, C++-like scoping
           rules are used to find the type (i.e. first the nested types within this
           message are searched, then within the parent, on up to the root
           namespace).

      `optional string type_name = 6;`
      Specified by:
        `getTypeName` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### getTypeNameBytes

          public ByteString getTypeNameBytes()

           For message and enum types, this is the name of the type.  If the name
           starts with a '.', it is fully-qualified.  Otherwise, C++-like scoping
           rules are used to find the type (i.e. first the nested types within this
           message are searched, then within the parent, on up to the root
           namespace).

      `optional string type_name = 6;`
      Specified by:
        `getTypeNameBytes` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### hasExtendee

          public boolean hasExtendee()

           For extensions, this is the name of the type being extended.  It is
           resolved in the same manner as type_name.

      `optional string extendee = 2;`
      Specified by:
        `hasExtendee` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### getExtendee

          public java.lang.String getExtendee()

           For extensions, this is the name of the type being extended.  It is
           resolved in the same manner as type_name.

      `optional string extendee = 2;`
      Specified by:
        `getExtendee` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### getExtendeeBytes

          public ByteString getExtendeeBytes()

           For extensions, this is the name of the type being extended.  It is
           resolved in the same manner as type_name.

      `optional string extendee = 2;`
      Specified by:
        `getExtendeeBytes` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### hasDefaultValue

          public boolean hasDefaultValue()

           For numeric types, contains the original text representation of the value.
           For booleans, "true" or "false".
           For strings, contains the default text contents (not escaped in any way).
           For bytes, contains the C escaped value.  All bytes >= 128 are escaped.
           TODO(kenton):  Base-64 encode?

      `optional string default_value = 7;`
      Specified by:
        `hasDefaultValue` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### getDefaultValue

          public java.lang.String getDefaultValue()

           For numeric types, contains the original text representation of the value.
           For booleans, "true" or "false".
           For strings, contains the default text contents (not escaped in any way).
           For bytes, contains the C escaped value.  All bytes >= 128 are escaped.
           TODO(kenton):  Base-64 encode?

      `optional string default_value = 7;`
      Specified by:
        `getDefaultValue` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### getDefaultValueBytes

          public ByteString getDefaultValueBytes()

           For numeric types, contains the original text representation of the value.
           For booleans, "true" or "false".
           For strings, contains the default text contents (not escaped in any way).
           For bytes, contains the C escaped value.  All bytes >= 128 are escaped.
           TODO(kenton):  Base-64 encode?

      `optional string default_value = 7;`
      Specified by:
        `getDefaultValueBytes` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### hasOneofIndex

          public boolean hasOneofIndex()

           If set, gives the index of a oneof in the containing type's oneof_decl
           list.  This field is a member of that oneof.

      `optional int32 oneof_index = 9;`
      Specified by:
        `hasOneofIndex` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### getOneofIndex

          public int getOneofIndex()

           If set, gives the index of a oneof in the containing type's oneof_decl
           list.  This field is a member of that oneof.

      `optional int32 oneof_index = 9;`
      Specified by:
        `getOneofIndex` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### hasJsonName

          public boolean hasJsonName()

           JSON name of this field. The value is set by protocol compiler. If the
           user has set a "json_name" option on this field, that option's value
           will be used. Otherwise, it's deduced from the field's name by converting
           it to camelCase.

      `optional string json_name = 10;`
      Specified by:
        `hasJsonName` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### getJsonName

          public java.lang.String getJsonName()

           JSON name of this field. The value is set by protocol compiler. If the
           user has set a "json_name" option on this field, that option's value
           will be used. Otherwise, it's deduced from the field's name by converting
           it to camelCase.

      `optional string json_name = 10;`
      Specified by:
        `getJsonName` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### getJsonNameBytes

          public ByteString getJsonNameBytes()

           JSON name of this field. The value is set by protocol compiler. If the
           user has set a "json_name" option on this field, that option's value
           will be used. Otherwise, it's deduced from the field's name by converting
           it to camelCase.

      `optional string json_name = 10;`
      Specified by:
        `getJsonNameBytes` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### hasOptions

          public boolean hasOptions()

      `optional .google.protobuf.FieldOptions options = 8;`
      Specified by:
        `hasOptions` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### getOptions

          public DescriptorProtos.FieldOptions getOptions()

      `optional .google.protobuf.FieldOptions options = 8;`
      Specified by:
        `getOptions` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### getOptionsOrBuilder

          public DescriptorProtos.FieldOptionsOrBuilder getOptionsOrBuilder()

      `optional .google.protobuf.FieldOptions options = 8;`
      Specified by:
        `getOptionsOrBuilder` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

    - #### isInitialized

          public final boolean isInitialized()

      Description copied from interface: `MessageLiteOrBuilder`
      Returns true if all required fields in the message and all embedded messages are set, false otherwise.

      See also: `MessageOrBuilder.getInitializationErrorString()`

      Specified by:
        `isInitialized` in interface `MessageLiteOrBuilder`
      Overrides:
        `isInitialized` in class `GeneratedMessageV3`

    - #### writeTo

          public void writeTo(CodedOutputStream output)
                       throws java.io.IOException

      Description copied from interface: `MessageLite`
      Serializes the message and writes it to `output`. This does not flush or close the stream.
      Specified by:
        `writeTo` in interface `MessageLite`
      Overrides:
        `writeTo` in class `GeneratedMessageV3`
      Throws:
        `java.io.IOException`

    - #### getSerializedSize

          public int getSerializedSize()

      Description copied from interface: `MessageLite`
      Get the number of bytes required to encode this message. The result is only computed on the first call and memoized after that.
      Specified by:
        `getSerializedSize` in interface `MessageLite`
      Overrides:
        `getSerializedSize` in class `GeneratedMessageV3`

    - #### equals

          public boolean equals(java.lang.Object obj)

      Description copied from interface: `Message`
      Compares the specified object with this message for equality. Returns `true` if the given object is a message of the same type (as defined by `getDescriptorForType()`) and has identical values for all of its fields. Subclasses must implement this; inheriting `Object.equals()` is incorrect.
      Specified by:
        `equals` in interface `Message`
      Overrides:
        `equals` in class `AbstractMessage`
      Parameters:
        `obj` - object to be compared for equality with this message
      Returns:
        `true` if the specified object is equal to this message

    - #### hashCode

          public int hashCode()

      Description copied from interface: `Message`
      Returns the hash code value for this message. The hash code of a message should mix the message's type (object identity of the descriptor) with its contents (known and unknown field values). Subclasses must implement this; inheriting `Object.hashCode()` is incorrect.
      Specified by:
        `hashCode` in interface `Message`
      Overrides:
        `hashCode` in class `AbstractMessage`
      Returns:
        the hash code value for this message
      See Also:
        `Map.hashCode()`

    - #### parseFrom

          public static DescriptorProtos.FieldDescriptorProto parseFrom(java.nio.ByteBuffer data)
                                                                 throws InvalidProtocolBufferException

      Throws:
        `InvalidProtocolBufferException`

    - #### parseFrom

          public static DescriptorProtos.FieldDescriptorProto parseFrom(java.nio.ByteBuffer data,
                                                        ExtensionRegistryLite extensionRegistry)
                                                                 throws InvalidProtocolBufferException

      Throws:
        `InvalidProtocolBufferException`

    - #### parseFrom

          public static DescriptorProtos.FieldDescriptorProto parseFrom(ByteString data)
                                                                 throws InvalidProtocolBufferException

      Throws:
        `InvalidProtocolBufferException`

    - #### parseFrom

          public static DescriptorProtos.FieldDescriptorProto parseFrom(ByteString data,
                                                        ExtensionRegistryLite extensionRegistry)
                                                                 throws InvalidProtocolBufferException

      Throws:
        `InvalidProtocolBufferException`

    - #### parseFrom

          public static DescriptorProtos.FieldDescriptorProto parseFrom(byte[] data)
                                                                 throws InvalidProtocolBufferException

      Throws:
        `InvalidProtocolBufferException`

    - #### parseFrom

          public static DescriptorProtos.FieldDescriptorProto parseFrom(byte[] data,
                                                        ExtensionRegistryLite extensionRegistry)
                                                                 throws InvalidProtocolBufferException

      Throws:
        `InvalidProtocolBufferException`

    - #### parseFrom

          public static DescriptorProtos.FieldDescriptorProto parseFrom(java.io.InputStream input)
                                                                 throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### parseFrom

          public static DescriptorProtos.FieldDescriptorProto parseFrom(java.io.InputStream input,
                                                        ExtensionRegistryLite extensionRegistry)
                                                                 throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### parseDelimitedFrom

          public static DescriptorProtos.FieldDescriptorProto parseDelimitedFrom(java.io.InputStream input)
                                                                          throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### parseDelimitedFrom

          public static DescriptorProtos.FieldDescriptorProto parseDelimitedFrom(java.io.InputStream input,
                                                                 ExtensionRegistryLite extensionRegistry)
                                                                          throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### parseFrom

          public static DescriptorProtos.FieldDescriptorProto parseFrom(CodedInputStream input)
                                                                 throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### parseFrom

          public static DescriptorProtos.FieldDescriptorProto parseFrom(CodedInputStream input,
                                                        ExtensionRegistryLite extensionRegistry)
                                                                 throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### newBuilderForType

          public DescriptorProtos.FieldDescriptorProto.Builder newBuilderForType()

      Description copied from interface: `MessageLite`
      Constructs a new builder for a message of the same type as this message.
      Specified by:
        `newBuilderForType` in interface `Message`
      Specified by:
        `newBuilderForType` in interface `MessageLite`

    - #### newBuilder

          public static DescriptorProtos.FieldDescriptorProto.Builder newBuilder()

    - #### newBuilder

          public static DescriptorProtos.FieldDescriptorProto.Builder newBuilder(DescriptorProtos.FieldDescriptorProto prototype)

    - #### toBuilder

          public DescriptorProtos.FieldDescriptorProto.Builder toBuilder()

      Description copied from interface: `MessageLite`
      Constructs a builder initialized with the current message. Use this to derive a new message from the current one.
      Specified by:
        `toBuilder` in interface `Message`
      Specified by:
        `toBuilder` in interface `MessageLite`

    - #### newBuilderForType

          protected DescriptorProtos.FieldDescriptorProto.Builder newBuilderForType(GeneratedMessageV3.BuilderParent parent)

      Description copied from class: `GeneratedMessageV3`
      TODO(xiaofeng): remove this together with GeneratedMessageV3.BuilderParent.
      Specified by:
        `newBuilderForType` in class `GeneratedMessageV3`

    - #### getDefaultInstance

          public static DescriptorProtos.FieldDescriptorProto getDefaultInstance()

    - #### parser

          public static Parser<DescriptorProtos.FieldDescriptorProto> parser()

    - #### getParserForType

          public Parser<DescriptorProtos.FieldDescriptorProto> getParserForType()

      Description copied from interface: `MessageLite`
      Gets the parser for a message of the same type as this message.
      Specified by:
        `getParserForType` in interface `Message`
      Specified by:
        `getParserForType` in interface `MessageLite`
      Overrides:
        `getParserForType` in class `GeneratedMessageV3`

    - #### getDefaultInstanceForType

          public DescriptorProtos.FieldDescriptorProto getDefaultInstanceForType()

      Description copied from interface: `MessageLiteOrBuilder`
      Get an instance of the type with no fields set. Because no fields are set, all getters for singular fields will return default values and repeated fields will appear empty. This may or may not be a singleton. This differs from the `getDefaultInstance()` method of generated message classes in that this method is an abstract method of the `MessageLite` interface whereas `getDefaultInstance()` is a static method of a specific class. They return the same thing.
      Specified by:
        `getDefaultInstanceForType` in interface `MessageLiteOrBuilder`
      Specified by:
        `getDefaultInstanceForType` in interface `MessageOrBuilder`